package net.porkbuns.my_story;

import java.util.ArrayList;
import java.util.Map;

import net.porkbuns.my_story.api.Item;
import net.porkbuns.my_story.api.User;
import android.content.Context;
import android.util.AttributeSet;
import android.widget.AbsoluteLayout;
import android.widget.ImageView;

public class AvatarLayout extends AbsoluteLayout {
	private ImageView mHeadView, mShirtView, mPantsView, mBodyView;
	private User currentUser;
	
	public AvatarLayout(Context context) {
		super(context);
		setup(context);
	}

	@SuppressWarnings("unchecked")
	public AvatarLayout(Context context, AttributeSet attrs, Map inflateParams) {
		super(context, attrs, inflateParams);
		setup(context);
	}

	@SuppressWarnings("unchecked")
	public AvatarLayout(Context context, AttributeSet attrs, Map inflateParams,
			int defStyle) {
		super(context, attrs, inflateParams, defStyle);
	}

	private void setup(Context context) {
		mBodyView = new ImageView(context);
		mHeadView = new ImageView(context);
		mShirtView = new ImageView(context);
		mPantsView = new ImageView(context);
		addView(mBodyView, new AbsoluteLayout.LayoutParams(120, 160, 0, 0));
		addView(mHeadView, new AbsoluteLayout.LayoutParams(120, 60, 0, 22));
		addView(mPantsView, new AbsoluteLayout.LayoutParams(120, 50, 0, 88));
		addView(mShirtView, new AbsoluteLayout.LayoutParams(120, 50, 0, 60));
	}

	private String[] getTitles(ArrayList<Item> l) {
		int listSize = l.size();
		String[] r = new String[listSize];
		Item currentItem;

		for (int i = 0; i < listSize; i++) {
			currentItem = l.get(i);
			r[i] = currentItem.getName();
		}
		return r;
	}

	public String[] getHeadItemTitles() {
		User currentUser = User.getCurrentUser(mContext);
		return getTitles(currentUser.getHeadItems());
	}

	public String[] getShirtItemTitles() {
		User currentUser = User.getCurrentUser(mContext);
		return getTitles(currentUser.getShirtItems());
	}

	public String[] getPantsItemTitles() {
		User currentUser = User.getCurrentUser(mContext);
		return getTitles(currentUser.getPantsItems());
	}

	public void redraw() {
		
		if (currentUser.isMale()) {
			mBodyView.setImageResource(R.drawable.body);
		} else {
			mBodyView.setImageResource(R.drawable.f_body);
		}
		mHeadView.setImageBitmap(currentUser.getHead().getBitmap(mContext));
		mShirtView.setImageBitmap(currentUser.getShirt().getBitmap(mContext));
		mPantsView.setImageBitmap(currentUser.getPants().getBitmap(mContext));
	}
	
	public void setUser(User u) {
		currentUser = u;
	}
}
