package net.porkbuns.my_story;

import net.porkbuns.my_story.api.User;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;

public class CreateAccount extends Activity {
	private EditText mEmailText;
	private EditText mPhoneNumberText;
	private Spinner mGenderSpinner;
	private Button mNextButton;
	private LinearLayout mLayout;
	private ProgressDialog pd;
	private long phone;
	private boolean male;

	private String[] mGenders = new String[] { "Male", "Female" };

	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.createcharacter);
		setTitle("My Story > Create Account");

		mLayout = (LinearLayout) findViewById(R.id.widget56);
		mEmailText = (EditText) this.findViewById(R.id.email);
		mPhoneNumberText = (EditText) this.findViewById(R.id.phone_number);
		mPhoneNumberText
				.setText(android.os.SystemProperties
						.get(android.telephony.TelephonyProperties.PROPERTY_LINE1_NUMBER));
		mNextButton = (Button) this.findViewById(R.id.next_button);

		mNextButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// massage phone number
				phone = 0;
				String phoneText = mPhoneNumberText.getText().toString();
				if (phoneText.length() > 0) {
					phone = Long.parseLong(phoneText, 10);
				}
				
				// get male boolean
				male = mGenderSpinner.getSelectedItemPosition() == User.MALE;
				
				pd = ProgressDialog.show(CreateAccount.this, "Contacting server", "Creating Account", true, false);
				
				mLayout.setEnabled(false);
				mLayout.setFocusable(false);
				
				new Thread(new Runnable() {
					public void run() {
						User.create(mEmailText.getText().toString(), phone, male,
								CreateAccount.this);
						pd.dismiss();
						Intent i = new Intent(CreateAccount.this, EditAvatar.class);
						startSubActivity(i, 0);
					}
				}).start();
			}
		});

		mGenderSpinner = (Spinner) this.findViewById(R.id.gender);

		ArrayAdapter<String> genderAdapter = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, mGenders);

		genderAdapter
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		mGenderSpinner.setAdapter(genderAdapter);

		mGenderSpinner.getSelectedItemPosition();

	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		super.onActivityResult(requestCode, resultCode, data, extras);
		mLayout.setEnabled(true);
		mLayout.setFocusable(true);
		
		switch (resultCode) {
		case RESULT_OK:
			setResult(RESULT_OK);
			finish();
			break;
		case RESULT_CANCELED:
			break;
		}
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

		switch (keyCode) {
		case KeyEvent.KEYCODE_BACK:
			setResult(RESULT_FIRST_USER);
			finish();
			break;
		}

		return super.onKeyDown(keyCode, event);
	}
}
