package net.porkbuns.my_story;

import net.porkbuns.my_story.api.User;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.Gallery.LayoutParams;

public class EditRoomAvatarMain extends Activity {
	//public final static int NUMIMAGES = 4;
	//public static int[] mImages = new int[NUMIMAGES];  // stores positions in trophies list of what images to show
	//public final static String ROOM_FILE_NAME = "roomData.txt";
	//public static Item[] gallery = new Item[NUMIMAGES];;
	
	// requestCode's used for different activities
	private final int EDIT_ROOM_ACTIVITY = 1;
	private final int EDIT_AVATAR_ACTIVITY = 2;
	
	
	AvatarLayout avatarLayout;
	
	//private AbsoluteLayout abs;
	
	public static final String EDIT_AVATAR_PASS_INFO = "info_to_send_to_edit_avatar";
	
	// Avatar image stuff
	/*ImageView mImageViewBody;
	ImageView mImageViewHead;
	ImageView mImageViewShirt;
	ImageView mImageViewPants;
	private Integer[] mHeadIds = {R.drawable.head0, R.drawable.head1, R.drawable.head2};
    private Integer[] mShirtIds = {R.drawable.shirt0, R.drawable.shirt1, R.drawable.shirt2};
    private Integer[] mPantsIds = {R.drawable.pants0, R.drawable.pants1, R.drawable.pants2};*/
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.edit_room_avatar_main);
        
        setTitle("My Story > You");
        
        // Load a background for the current screen from the "room_background" drawable
        this.getWindow().setBackgroundDrawableResource(R.drawable.roombackgroundedit);
        
        // grab the avatar layout
        avatarLayout = (AvatarLayout) findViewById(R.id.avatar_layout_main);
        avatarLayout.setUser(User.getCurrentUser(this));
        GridView g = (GridView) findViewById(R.id.myGrid);
        g.setAdapter(new ImageAdapterRoomView(this, User.getCurrentUser(this)));
        // make the room view un-selectable
        g.setFocusable(false);
        
        avatarLayout.redraw();
    }
    
    // handles key presses
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {		
		super.onKeyDown(keyCode, event);
		
		switch (keyCode) {
		case KeyEvent.KEYCODE_DPAD_CENTER: {  // open the options menu
			openOptionsMenu();
			return true;
		}
		}
		return false;
	}
    
    /**
	 * onActivityResult() - called when switching back to this activity
	 * 		in my code, requestCode can only be EDIT_ROOM_ACTIVITY or EDIT_AVATAR_ACTIVITY
	 * 
	 * @param requestCode - integer for knowing where the result is from
	 * @param resultCode - integer returned by the child activity
	 * @param data - String data result of the child activity
	 * @param extras - Bundle holding additional result information
	 */
	protected void onActivityResult(int requestCode, int resultCode, String data, Bundle extras) {
		super.onActivityResult(requestCode, resultCode, data, extras);
		
		if (requestCode == EDIT_ROOM_ACTIVITY) {
			// reload the grid
			GridView g = (GridView) findViewById(R.id.myGrid);
			g.setAdapter(new ImageAdapterRoomView(this, User.getCurrentUser(this)));
			g.setFocusable(false);
			return;
		}
		else if (requestCode == EDIT_AVATAR_ACTIVITY) {
			avatarLayout.redraw();
			return;
		}
		else {
			return;
		}
	}
	
	
    
    // gives an options menu for editing the room and avatar
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		
		menu.add(0, 0, "Edit Room", R.drawable.menu_room);
		menu.add(0, 1, "Edit Avatar", R.drawable.menu_user);
		return true;
	}
	
	// handle selection of items in the menu (search, goto prev page, and goto next page)
	@Override
	public boolean onOptionsItemSelected(Menu.Item item) {
		switch (item.getId()) {
		case 0: {  // edit room
			Intent i = new Intent(this, EditRoom.class);
			startSubActivity(i, EDIT_ROOM_ACTIVITY);		
			return true;
		}
		case 1: {  // edit avatar			
			Intent i = new Intent(this, EditAvatar.class);
			i.putExtra(EDIT_AVATAR_PASS_INFO, 1);
			startSubActivity(i, EDIT_AVATAR_ACTIVITY);		
			return true;
		}
		}
		return super.onOptionsItemSelected(item);
	}
	
    // makeView() - from Android View Gallery's Grid2.java file
    public View makeView() {
    	ImageView i = new ImageView(this);
        i.setBackgroundColor(0xFF000000);
        i.setScaleType(ImageView.ScaleType.FIT_CENTER);
        i.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,
                LayoutParams.FILL_PARENT));
        return i;
    }
    
    
}