package net.porkbuns.my_story;

import java.util.ArrayList;
import java.util.HashMap;

import net.porkbuns.my_story.api.User;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Contacts.Phones;
import android.view.View;
import android.widget.ListView;
import android.widget.SimpleAdapter;

public class Friends extends ListActivity {
	private ArrayList<HashMap<String,String>> displayList = new ArrayList<HashMap<String,String>>();
	public static ArrayList<User> friendList;
	private Handler msgHandler;
	private ProgressDialog pd;
	
    @Override
    protected void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setTitle("My Story > Friends");
        msgHandler = new Handler();
        pd = ProgressDialog.show(this, "Contacting server", "Loading friends", true, false);
        new LoadThread().start();
    }
    
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	
     	Intent i = new Intent(this, Friend.class);
     	i.putExtra("Position", position);
     	i.putExtra("Name", displayList.get(position).get("Name"));
     	startSubActivity(i, 0);
     	
    }
    
    protected class LoadThread extends Thread
	{
		public void run() {
			Cursor c = getContentResolver().query(Phones.CONTENT_URI, null, null, null, null);
			c.first();
			friendList = new ArrayList<User>();
	        if (c.count() > 0) { 
		        do {
		        	long phone = Long.parseLong(c.getString(1));
		        	User u = User.get(phone);
		        	if (u != null) {
		        		HashMap<String,String> item = new HashMap<String,String>();
		          	  	item.put( "Name",c.getString(3) );
		          	  	item.put( "Phone",c.getString(1));
		          	  	displayList.add( item );
		          	  	
		          	  	u.getHead().getBitmap(Friends.this);
		          	  	u.getShirt().getBitmap(Friends.this);
		          	  	u.getPants().getBitmap(Friends.this);
		          	  	friendList.add(u);
		        	}
		        }
		        while(c.next());
	        }
		    SimpleAdapter adapter = new SimpleAdapter( 
		    								Friends.this, 
											displayList,
								  			R.layout.questlisting,
								  			new String[] { "Name", "Phone" },
			  				                new int[] { R.id.text1, R.id.text2 } );
			msgHandler.post(new UpdateUIThread(adapter));
		}
	}
    
    protected class UpdateUIThread extends Thread
    {
    	private SimpleAdapter adapter;
    	
    	public UpdateUIThread(SimpleAdapter adapter) {
    		this.adapter = adapter;
    	}
    	
    	public void run() {
    		setListAdapter(adapter);
	        setSelection(0);
	        getListView().requestFocus();
			pd.dismiss();
    	}
    }
}
