package net.porkbuns.my_story;

import net.porkbuns.my_story.api.Item;
import net.porkbuns.my_story.api.User;
import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Gallery;
import android.widget.ImageView;

// ImageAdapter class - slightly modified from Android View Gallery's Grid2.java file
public class ImageAdapterRoomView extends BaseAdapter {
	private User currentUser;
    public ImageAdapterRoomView(Context c, User u) {
        mContext = c;
        currentUser = u;
    }

    public int getCount() {
        return User.ROOMSIZE;
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ImageView i = new ImageView(mContext);
        Item roomItem = currentUser.getRoomItem(position); 
        if (roomItem != null) {
        	i.setImageDrawable(roomItem.getDrawable(mContext));
        }
        //i.setImageResource(mImages[position]);
        
        i.setLayoutParams(new Gallery.LayoutParams(60, 75));
        i.setAdjustViewBounds(false);
        i.setScaleType(ImageView.ScaleType.CENTER);
        i.setBackground(R.drawable.trophy_frame);
        return i;
    }

    private Context mContext;
}